#!/usr/bin/perl

# Proyecto ircHa v1.0.2 (IRC Hablado)
# Versin de frontend mono thread para windows
# Codgo por Juan Ignacio Rodrguez
# Para un proyecto idea de Angel del Valle

# Para errores y/o sugerencias escribir a ircha@terra.es

use Win32::Sound;
use Win32::Semaphore;

$volumen = 3;   # Volumen de la voz entre 1 (bajo) y 8 (fuerte).
$tempo = 0.8;   # Tempo de la voz, 1 normal, cuanto mas pequeo mas rapido.

$flood = 1;	# Proteccin anti-flood, poner a cero para desconectar
$banlist = 1;   # Lista de prohibicin, poner a cero para desconectar

# Variables de entorno, en ellas estan los nombres de los ficheros y directorios que ircHa usa
# En condiciones normales no debe modificarse por el usuario

$tmpdir = $ENV{'TEMP'};		# Directorio temporal
$ircha_dir = ($_ = rindex($0, '\\')) < 1 ? '.' : substr($0, 0, $_);	# En este directorio esta instalada la aplicacin

$ircha_log = "$tmpdir/ircha.log";  	   # Log de flood
$ircha_tmp = "$tmpdir/ircha_";		   # Nombre de los ficheros temporales

$configfile = "$ircha_dir/ircha.conf";	   # Fichero de configuracin		
$diccionario = "$ircha_dir/diccionario";   # Diccionario
$banlistfile = "$ircha_dir/banlist";	   # Banlist
$mbrola_cmd  = "$ircha_dir/mbrola"; 	   # Ubicacin del Mbrola
$basefonetica = "$ircha_dir/es1/es1";	   # Fichero de libreria fonetica

# Poner esta variable a 1 para ver en STDERR la trascripcin fontica
$debug = 0;

require "$ircha_dir/irchalib.pl";
require "$ircha_dir/ttp.pl";

# Inicializamos la configuracin, el diccionario y la banlist
leer_configuracion($configfile);
leer_diccionarios($diccionario, "$diccionario.user");
leer_banlists($banlistfile);

# Si hay linea de comandos la tomamos como cadena a leer,
# sino tomamos la entrada standar y damos en la salida standar
if($#ARGV == -1)
{
	while(<STDIN>)
	{
		$_ = transcribe($_);

	        print STDERR "$_\n" if($debug);

	        print "$_\n";
	}
}
else
{
        # Creamos un semaforo en el sistema para comprobar si ya estamos usando la tarjeta de sonido
        my $ircha_sem = Win32::Semaphore->new(1, 1, 'ircha');
        die "No puedo crear o acceder al semaforo del sistema ($!)." if(!defined($ircha_sem));
        
        # Comprobamos el estado del semaforo hasta que este libre,
        # y cuando lo este lo bloqueamos.
        # Si en ~20 segundos no esta disponible suspendemos la ejecucin
        if($ircha_sem->wait(20000))
        {

        	$_ = join(' ', @ARGV);
        
                # Eliminamos los cdigos de colorines del irc
        
                s/\003\d\d,\d\d//g;
                s/\003\d\d,\d//g;
                s/\003\d,\d\d//g;
                s/\003\d,\d//g;
                s/\003\d\d//g;
                s/\003\d//g;
        
                # Filtrado de caracteres Extraos
        
        	tr/[\0-\37]//;
	        tr/[\40-~\241\243\246\252\272\277\300-\305\307-\317\321-\326\331-\335\337-\345\347-\357\361-\366\371-\375]/ /c;        

        	exit if(flood_control($_) || banlist_control($_));
        
        	$_ = transcribe($_, 1);
        	
                print STDERR "$_\n" if($debug);
        
        	play($_);

		$ircha_sem->release();
        }
        else
	{
		print STDERR "Ejecucin abortada, recurso bloqueado.\n";
	}
}

sub play
{
        my $mbrola_tmp = $ircha_tmp.join('', (0..9,'a'..'z')[rand 36, rand 36, rand 36, rand 36]);

        open(FILE, "|$mbrola_cmd -v $volumen -t $tempo $basefonetica - $mbrola_tmp.wav");
	print FILE $_[0];
        close(FILE);

	Win32::Sound::Play("$mbrola_tmp.wav", SND_NODEFAULT);

        unlink("$mbrola_tmp.wav");
}
