# Libreria de funciones de uso general para IRCHA

# Rudimentario control de flood, por si alguien repite insistentemente una frase
sub flood_control
{
	local $_ = $_[0];
	my($buffer, $i);
	if($flood)
	{
        	$i = (stat($ircha_log))[9];
        	if(time() <= ($i + 10))
        	{
                	open(FILE, "<$ircha_log");
                	$buffer = <FILE>;
                	chop($buffer);
                	close(FILE);
                
                	if($buffer eq $_)
                	{
                		print STDERR "Proteccin antiflood activada.\n" if($debug);
                		return 1;
        		}
        	}
        
        	open(FILE, ">$ircha_log");
        	print FILE "$_\n";
        	close(FILE);
        	###
	}
	return 0;
}

# Lista de prohibicin, si se menciona lo contenido en la lista, no se lee
sub banlist_control
{
	local $_ = $_[0];
	my $i;
	if($banlist)
	{
        	foreach $i (@banlist)
        	{
        		if(/$i/)
        		{
        	       		print STDERR "Banlist activada ($i).\n" if($debug);
        	       		return 1;
        		}
        	}
	}
	return 0;
}

# Leemos las lista de prohibiciones
sub leer_banlists
{
	local $_;
	my $file;
        foreach $file (@_)
        {
                if(open(FILE, $file))
                {
        	        while(<FILE>)
        	        {
                        	chop;
        	                push(@banlist, $_) if((! /^\#/) && ($_ ne ''));
                	}
        	        close(FILE);
		}
        }
}

# Leemos los diccionarios
sub leer_diccionarios
{
	my($l, $file);
        foreach $file (@_)
        {
                if(open(FILE, $file))
                {
                        while($l = <FILE>)
                        {
                                chop($l);
                                if(($l !~ /^\#/) && ($l ne ''))
                                {
                                        $l =~ s/^\\//;
                                        ($a, $b) = split(/[\t ]/, $l, 2);

                                        # Filtrado de caracteres Extraos
                                        $b =~ tr/[\0-\37]//;
                                        $b =~ tr/[\40-~\241\243\246\252\272\277\300-\305\307-\317\321-\326\331-\335\337-\345\347-\357\361-\366\371-\375]/ /c;
                                        $b =~ s/\.\.\./\376/g; # Una posible implementacin de los puntos suspensivos
				        # Pasamos de maysculas a minsculas, tambien convertimos los acentos extraos en normales
					$b =~ tr[A-Z\300\301\302\303\304\305\307\310\311\312\313\314\315\316\317\321\322\323\324\325\326\331\332\333\334\335\337\340\343\344\345\350\353\354\357\362\364\365\366\371\375\377]
          					[a-z\341\341\342\341\341\341\347\351\351\352\351\355\355\355\355\361\363\363\364\363\363\372\372\373\374\355\142\341\341\341\341\351\351\355\355\363\363\363\363\372\355\355];

                                        $diccionario{lc $a} = $b;
                                }
                        }
                        close(FILE);
                }
        }
}

# Leemos el/los fichero/s de configuracion
sub leer_configuracion
{
	my($file, $l);
        foreach $file (@_)
        {
                if(open(FILE, $file))
                {
                        while($l = <FILE>)
                        {
                                chomp($l);
                                $l =~ s/\r//g;
                                if(($l !~ /^\#/) && ($l ne ''))
                                {
                                        ($a, $b) = split(/[\t ]/, $l, 2);
                                        eval("\$$a = \"$b\"");
                                }
                        }
                        close(FILE);
                }
        }
}

1;
