# Proyecto ircHa rutina de texto a phonemas v1.0.3 (En formato libreria)

# Traductor de texto a fonemas para MBrola y enfocado a su uso en IRC (2001)
# Codificado por Juan Ignacio Rodrguez
# Para un proyecto idea de Angel del Valle
# Basado en un cdigo original de Alistair Conkie (1997)

# Para errores y/o sugerencias escribir a ircha@terra.es

# Inicializacin de variables a la configuracin por defecto

# Poner a cero si no se quere que lea los puntos y comas, y los considere casi todos como puntuacin.
$lee_el_punto = 1;

# Poner a cero si no queremos leer las cosas que parezcan una hora
$lee_la_hora = 1;

# Poner a cero si no queremos leer las cosas que parezcan una URL
$lee_las_URLs = 1;

# Relacin de palabras tonas
%atonas = (
# Artculos
        'el', 1,
        'la', 1,
        'los', 1,
        'las', 1,
        'del', 1, # En realidad no es un rticulo

# Adjetivos posesivos antepuestos
        'mi', 1,
        'mis', 1,
        'tu', 1,
        'tus', 1,
        'su', 1,
        'sus', 1,
        'nwestro', 1,
        'nwestra', 1,
        'nwestros', 1,
        'nwestras', 1,
        'bwestro', 1,
        'bwestra', 1,
        'bwestros', 1,
        'bwestras', 1,

# Pronombres personales complementos sin preposisicin
        'me', 1,
        'te', 1,
        'se', 1,
        'nos', 1,
        'os', 1,
        'bos', 1,
        'les', 1,
        'lo', 1,
        'si', 1,

# Prepocisiones excepto segun
        'a',    1,
        'ante', 1,
        'baxo', 1,
        'kabe', 1,
        'kon', 1,
        'kontra', 1,
        'de', 1,
        'desde', 1,
        'en', 1,
        'entre', 1,
        'azja', 1,
        'asta', 1,
        'para', 1,
        'por', 1,
        "segu:n", 1,
        'sin', 1,
        'so', 1,
        'sobre', 1,
        'tras', 1,

# Conjunciones
        'ni', 1,
        'ya', 1,
        'bjen', 1,
        'pero', 1,
        'aunke', 1,
        'porke', 1,
        'pero', 1,

# Pronombres relativos
        'kjen', 1,
        'ke', 1,
        'kwal', 1,
        'kuyo', 1,
        'kuya', 1,
        'kuyos', 1,
        'kuyas', 1,
        'kwanto', 1,
        'kwanta', 1,
        'kwantos', 1,
        'kwantas', 1,
        'kwal', 1,
        'kwales', 1,
        'sino', 1,
        'kwan', 1,
        'mas', 1,

# Advervios y adjetivos relativos
        'pwes', 1,
        'donde', 1,
        'kwando', 1,
        'pwesto', 1,
        'tan', 1,
        'mjentras', 1,
        'zerka', 1,
        'frente', 1,
        'aun', 1,
        'kasi', 1,
        'komo', 1
);

# Equivalencia entre los simbolos internos y los fonemas reales de Mbrola
%ttp2sampa = (
        '#', '_',
        'a', 'a',
        'e', 'e',
        'i', 'i',
        'o', 'o',
        'u', 'u',
        'a:', 'a',
        'e:', 'e',
        'i:', 'i',
        'o:', 'o',
        'u:', 'u',
        'a1', 'a',
        'e1', 'e',
        'i1', 'i',
        'o1', 'o',
        'u1', 'u',
        'a1:', 'a',
        'e1:', 'e',
        'i1:', 'i',
        'o1:', 'o',
        'u1:', 'u',
        'j', 'i',
        'W', 'u',
        'w', 'w',
        'Y', 'jj',
        'C', 'tS',
        's', 's',
        'S', 's',
        'p', 'p',
        'b', 'b',
        'B', 'b',
        'f', 'f',
        't', 't',
        'T', 't',
        'd', 'd',
        'D', 'd',
        'z', 'T',
        'k', 'k',
        'g', 'g',
        'G', 'g',
        'x', 'x',
        'm', 'm',
        'n', 'n',
        '~', 'J',
        'N', 'n',
        'M', 'm',
        'l', 'l',
        'I', 'l',
        'L', 'L',
        'r', 'r',
        'R', 'rr',
);

# Duraciones bsicas
%duracion = (
	'#', '',	# Las pausas no tienen duracin
        'a', '90',      # La a normal
        'e', '90',      # La e normal
        'i', '80',      # La i normal
        'o', '90',      # La o normal
        'u', '80',      # La u normal
        'a1', '108',    # La a larga
        'e1', '108',    # La e larga
        'i1', '98',     # La i larga
        'o1', '108',    # La o larga
        'u1', '96',     # La u larga
        'a1:', '208',   # La a larga con acento
        'e1:', '208',   # La e larga con acento
        'i1:', '198',   # La i larga con acento (era 96)
        'o1:', '208',   # La o larga con acento
        'u1:', '196',   # La u larga con acento
        'a:', '108',    # La a con acento
        'e:', '108',    # La e con acento
        'i:', '98',     # La i con acento (era 96)
        'o:', '108',    # La o con acento
        'u:', '96',     # La u con acento
        'j', '60',      # La i corta (Por ejemplo en diptongos)
        'W', '60',      # La u corta (dieresis, y cuando suena consonantica)
        'w', '45',
        'Y', '90',      # La y cuando suena como consonante
        'C', '110',     # La ch (135)
        's', '90',      # La s (Era 110 pero silbaban las eses)
        'S', '50',      # La s corta
        'p', '100',
        'b', '60',
        'B', '80',      # La B cuando suena fuerte como al principio de frase (Era 65 pero era demasiado corto)
        'f', '100',
        't', '85',
        'T', '95',      # T larga
        'd', '60',
        'D', '65',      # La D larga
        'z', '100',     # La z
        'k', '100',     # La k y la c cuando tiene fonema K
        'g', '50',
        'G', '80',      # La G larga
        'x', '130',     # La j con sonido consonate (como en jota)
        'm', '70',
        'M', '50',      # La M corta
        'n', '80',
        'N', '50',      # La N corta
        '~', '110',     # La 
        'l', '80',
        'I', '100',     # La l larga
        'L', '105',     # La LL
        'r', '50',      # La ere
        'R', '80',      # La erre
);

# Reglas de Phonetizacin, el orden NO es arbitrario
@txt2fonema = (
        ["\341", 'a:'],         # 'a
        ["\351", 'e:'],         # 'e
        ["\355", 'i:'],         # 'i
        ["\363", 'o:'],         # 'o
        ["\372", 'u:'],         # 'u
        ["\374", 'W'],          # u
        ["\342", 'a1'],         # ^a
        ["\352", 'e1'],         # ^e
        ["\356", 'i1'],         # ^i
        ["\364", 'o1'],         # ^o
        ["\373", 'u1'],         # ^u


        ['exa', 'egsa'],        # exacto, examen
#       ['xt', 'tst'],          # texto
        ['x ', 's '],           # linux (al final de palabra)
        ['x', 'ks'],            # taxi
        ['j', 'x'],             # jota

        ['ge', 'xe'],           # general
        ['gi', 'xi'],           # ginebra

        ['gue', 'ge'],          # guepardo
        ['gui', 'gi'],          # guinda
        ['hue', 'we'],          # huesca
        ['hie', 'Ye'],          # hierro
        ['que', 'ke'],          # que
        ['qui', 'ki'],          # quien

        ['ce', 'ze'],           # cero
        ['ci', 'zi'],           # cinco

        ['ya', 'Ya'],           # ya
        ['ye', 'Ye'],           # yeso
        ['yi', 'Yi'],
        ['yo', 'Yo'],
        ['yu', 'Yu'],           # yunque

        [' y a', ' j a'],       # La Y forma diptongo con la vocal siguiente
        [' y e', ' j e'],
        [' y i', ' j i'],
        [' y o', ' j o'],
        [' y u', ' j u'],

        ['y', 'i'],             # y
        ['ll', 'L'],            # llama

        ['ia', 'ja'],           # Diferentes diptongos
        ['ie', 'je'],
        ['io', 'jo'],
        ['iu', 'ju'],
        ['ua', 'Wa'],
        ['ue', 'We'],
        ['ui', 'Wi'],
        ['uo', 'Wo'],

        ['ch', 'C'],            # mucho
        ['sh', 'C'],            # shock (Anglicismos)
        ['ph', 'f'],            # Raphael 8-]

        ['rr', 'R'],            # torre
        [' r', ' R'],           # raton
        ["\\-r", '.R'],         # sub-rayar
        ['nr', 'nR'],           # Enrique
        ['lr', 'lR'],
        ['sr', 'SR'],           # A la vez hacemos la asimilacin

        ['b ', 'B '],           # Club (Al final de palabra, Anglicismos)
        ['l ', 'I '],           # canal (Al final de palabra)
        ['c', 'k'],             # casa
        ['q', 'k'],             # quorum
        ['v', 'b'],             # enviar
        ["\361", '~'],          # nio
        ['', 's'],             # Bara
        ['h', ''],              # La hache es muda

        # Asimilaciones
        ['# b', ' B'],          # La B al principio de frase, suena mas fuerte
        ['# d', ' D'],          # La D al principio de frase, suena mas fuerte
        ['# g', ' G'],          # La G al principio de frase, suena mas fuerte

        ['mb', 'MB'],           # La B despues de M, suena mas fuerte y la M ms suave
        ['m b', 'M B'],
        ['mg', 'MG'],           # La G despues de M, suena mas fuerte y la M ms suave
        ['m g', 'M G'],
        ['md', 'MD'],           # La D despues de M, suena mas fuerte y la M ms suave
        ['m d', 'M D'],
        ['nb', 'MB'],           # La B despues de N, suena mas fuerte y la N suena M suave
        ['n b', 'M B'],
        ['ng', 'NG'],           # La G despues de N, suena mas fuerte y la N ms suave
        ['n g', 'N G'],
        ['nd', 'ND'],           # La D despues de N, suena mas fuerte y la N ms suave
        ['n d', 'N D'],
        ['np', 'Mp'],           # Antes de P suena M y no N
        ['n p', 'M p'],

        ['p ', 'B '],           # La P al final de palabra suena B
        ['ps', 'Bs'],           # La P antes de S suena B
        ['t ', 'D '],           # La T al final de palabra suena D
        ['ts', 'Ds'],           # La T antes de S suena D

        ['sz', 'Sz'],           # La S antes de z suena ms corta
        ['s z', 'S z'],
        ['sb', 'Sb'],           # La S antes de b suena ms corta
        ['s b', 'S b'],
        ['sd', 'Sd'],           # La S antes de d suena ms corta
        ['s d', 'S d'],
        ['sg', 'Sg'],           # La S antes de g suena ms corta
        ['s g', 'S g'],
#       ['sR', 'SR'],
        ['s R', 'S R']          # La S antes de R suena ms corta
);

# Estos son los datos para la rutina de conversin de nmeros a letras
@unidades = ('cero', 'uno', 'dos', 'tres', 'cuatro', 'cinco', 'seis', 'siete', 'ocho', 'nueve');
@decenas1 = ('cero', 'diez', 'veinte', 'treinta', 'cuarenta', 'cincuenta', 'sesenta', 'setenta', 'ochenta', 'noventa');
@decenas2 = ('cero', 'dieci', 'venti', 'treinta y ', 'cuarenta y ', 'cincuenta y ', 'sesenta y ', 'setenta y ', 'ochenta y ', 'noventa y ');
@excepciones = ('diez','once', 'doce', 'trece', 'catorce', 'quince', 'dieciseis', 'diecisiete', 'dieciocho', 'diecinueve');
@centenas = ('cien', 'ciento', 'doscientos', 'trescientos', 'cuatrocientos', 'quinientos', 'seiscientos', 'setecientos', 'ochocientos', 'novecientos');
@prefijos = ('', 'mi', 'bi', 'tri', 'cuatri', 'quinti', 'sexti', 'septi', 'hepti', 'octi');

# Estos son los datos para la rutina de conversin de nmeros ordinales a letras
@uni_ord = ('cero', 'primer', 'segund', 'tercer', 'cuart', 'quint', 'sext', 'sptim', 'octav', 'noven');
@dec_ord = ('cero', 'dcim', 'vigsim', 'trigsim', 'cuadragsim', 'quincuagsim', 'sexagsim', 'septuagsim', 'octagsim', 'nonagsim');
@excep_ord = ('dcim', 'undcim', 'duodcim');
@pref_ord = ('centsim', '', 'duo', 'tri', 'cuadra', 'quincua', 'sexa', 'septa', 'octa', 'nona');

# Diccionario de sustitucin de palabras
%diccionario = (
                '-', 'guin',
                '<=', 'menor o igual que',
                '>=', 'mayor o igual que',
                'etc', 'etctera'
             );

# Forma de leer algunos caracteres especiales
@sustituciones = (
        ['%', ' por ciento '],
        ['#', ' canal '],
        ['$', ' dolar '],
        ['&', " \341mpersand "],
        ['*', ' asterisco '],
        ['+', " m\341s "],
        ['/', ' barra '],
        ['=', ' igual '],
        ['<', ' menor que '],
        ['>', ' mayor que '],
        ['@', ' arroba '],
        ["\\", ' barra invertida '],
        ['^', ' circunflejo '],
        ['_', ' subrayado '],
        ['~', ' tilde '],
        ['|', ' barra vertical '],
        ["\243", ' libra '] # simbolo libra esterlina
);

# Diccionario de deletreo
%deletrear = (
                'a', 'a',
                'b', 'be',
                'c', 'ce',
                'd', 'de',
                'e', 'e',
                'f', 'efe',
                'g', 'ge',
                'h', 'ache',
                'i', 'i',
                'j', 'jota',
                'k', 'ka',
                'l', 'ele',
                'm', 'eme',
                'n', 'ene',
                "\361", "e\361e",
                'o', 'o',
                'p', 'pe',
                'q', 'ku',
                'r', 'erre',
                's', 'ese',
                't', 'te',
                'u', 'u',
                'v', 'uve',
                'w', 'uvedoble',
                'x', 'ekis',
                'y', 'igriega',
                'z', 'zeta',
                '', 'cedilla'
             );

# Rutina principal de lectura,
# preprocesa la entrada, la divide en frases
# y la envia al proceso de sintesis
sub transcribe
{
        local $_ = $_[0];
        my $agregar_punto = $_[1];
        my @frases;
        my @fonetizacion = ();
        my($i, $j);

        # Filtrado de caracteres Extraos
        tr/[\0-\37]//;
        tr/[\40-~\241\243\246\252\272\277\300-\305\307-\317\321-\326\331-\335\337-\345\347-\357\361-\366\371-\375]/ /c;
        s/\.\.\./\376/g; # Una posible implementacin de los puntos suspensivos

        # Pasamos de maysculas a minsculas, tambien convertimos los acentos extraos en normales
        tr[A-Z\300\301\302\303\304\305\307\310\311\312\313\314\315\316\317\321\322\323\324\325\326\331\332\333\334\335\337\340\343\344\345\350\353\354\357\362\364\365\366\371\375\377]
          [a-z\341\341\342\341\341\341\347\351\351\352\351\355\355\356\355\361\363\363\364\363\363\372\372\373\374\355\142\341\341\341\341\351\351\355\355\363\363\363\363\372\355\355];

        $_ = diccionario($_); # Primera pasada de diccionario

        # Con esto intentamos evitar redundancias y discrepancias en la puntuacin
        tr/\140'\t\n/,,  /;                          # Los apostrofes los confunde con acentos y los tabuladores son espacios
        tr/\241\277\(\)\[\]\{\}\"]/,,,,,,,,,/;       # "Simplificamos" la puntuacin
        tr/\376?!,:;.\-//s;                          # Eliminamos redundancias en la puntuacin
        s/([\376?!,:;\.\\\/])/ $1 /g;                # "Espaciamos" las puntuacin

        # Sustituimos caracteres raros por su interpretacin leida
        foreach $i (@sustituciones)
        {
                $j = quotemeta($i->[0]);
                s/$j/$i->[1]/go;
        }

        $_ = diccionario($_, 1); # Segunda pasada de diccionario

        # Con esto intentamos evitar redundancias y discrepancias en la puntuacin (Segunda pasada)
        tr/\140'\t\n/,,  /;                          # Los apostrofes los confunde con acentos y los tabuladores son espacios
        tr/\241\277\(\)\[\]\{\}\"]/,,,,,,,,,/;       # "Simplificamos" la puntuacin
        tr/\376?!,:;.\-//s;                          # Eliminamos redundancias en la puntuacin
        s/([\376?!,:;\.\\\/\-])/ $1 /g;                # "Espaciamos" las puntuacin

        tr/\252\272/  /; # Eliminamos los ordinales que hayan podido quedar
        tr/ //s;         # Eliminamos espacios redundantes

        if(/[a-z\341\351\355\363\372\374\342\352\356\364\373]/) # Si hay algo que procesar
        {
                $j = $_; # Es necesario pasar la cadena a una variable temporar para escibar un extrao bug del perl
                $_ .= ' .' if($agregar_punto && ($j !~ /[\376\.!?,:;\-] $/)); # Aadimos el punto y final si es necesario

                @frases = ();
                foreach (split(/([\376.!?])/)) # Lo dividimos en frases
                {
                        if(/^[\376\.!?]$/)
                        {
                                $frases[$#frases] .= $_ if(!/\376/); # Si es un separador de frase lo aadimos a la ultima frase.
                        }
                        else
                        {
                                push(@frases, $_);
                        }
                }
                # Rutina principal del sintetizador fontico.
                foreach (@frases) # Para cada frase
                {
                        push(@fonetizacion, transcribe_frase($_)) if(/[a-z\341\351\355\363\372\374\342\352\356\364\373]/);
                }

                # Una vez tenemos la transcripcin fonetica, retornamos
                return join("\n", @fonetizacion);
        }
        else
        {
                return '';
        }
}

# Sustituye palabras del diccionario por sus equivalentes,
# adapta cosas como las URL a una formato "legible",
# y traduce los numeros a letras.
sub diccionario
{
        my $pasada = $_[1];
        local $_;
        my @salida = ();
        my $punto;

        foreach (split(/\s+/, $_[0]))
        {

                if(defined $diccionario{$_}) # Una palabra a convertir
                {
                        $_ = $diccionario{$_};
                        $punto = '';
                }
                else
                {
                        # Si termina en puntuacin, lo quitamos y lo guardamos
                        if(/[\.,\376]$/)
                        {
                                $punto = substr($_, length($_) - 1);
                                $_ = substr($_, 0, -1);
                        }
                        else
                        {
                                $punto = '';
                        }

                        # Pasamos la hora y las URl a una forma legible
                        if($lee_la_hora && (/(\d+):(\d+):(\d+)/ || /(\d\d)h(\d\d)m(\d\d)s/i))
                        {
                                $_ = "$1 horas $2 minutos $3 segundos";
                        }
                        elsif($lee_la_hora && /(\d\d):(\d\d)/)
                        {
                                $_ = "$1 hora $2 minutos";
                        }
                        elsif($lee_la_hora && /(\d\d)m(\d\d)s/i)
                        {
                                $_ = "$1 minutos $2 segundos";
                        }
                        elsif($lee_las_URLs && (/.*:\/\/.*\..*/ || /www\..*/ || /ftp\..*/))
                        {
                                s/\./ punto /g;
                                s/:/ dos puntos /g;
                                s/\?/ interrogacin /g;
                                s/\-/ guin /g;
                        }
                        # Si es un nmero o letras mezcladas con numeros tenemos que procesarlo
                        elsif(/[0-9]/)
                        {
                                my $tmp = '';
                                my @p = split(//);
                                for(my $i = 0; $i <= $#p; $i++)
                                {
                                        $tmp .= $p[$i];
                                        if(($p[$i] =~ /[0-9,\.\-\252\272]/) && ($p[$i + 1] !~ /[0-9,\.\-\252\272]/))
                                        {
                                                push(@salida, numero2letras($tmp));
                                                $tmp = '';
                                        }
                                        elsif(($p[$i] !~ /[0-9,\.\-\252\272]/) && ($p[$i + 1] =~ /[0-9,\.\-\252\272]/))
                                        {
                                                push(@salida, $tmp);
                                                $tmp = '';
                                        }
                                }
                                $_ = $tmp;
                        }
                        # Si empieza en punto
                        elsif((/^(\.)(.*)/) && ($2 ne ''))
                        {
                                $_ = "punto $2";
                        }
                        # Si tiene algun punto
                        elsif($lee_el_punto && /\./)
                        {
                                s/\./ punto /g;
                        }
                        # Si es la segunda pasada del diccionario
                        elsif($pasada)
                        {
                                # A las palabras comenzadas en sub se les aade un detalle para forzar el cambio de silaba
                                if(/^sub(lev|lin|lun|ray|rei|rep|rog)/)
                                {
                                       s/^sub/sub\-/;
                                }
                                # La palabras terminadas en mente en realidad son dos palabras
                                elsif(/mente$/ && !/^(aumente|lamente|tormente)$/)
                                {
                                        s/mente$/ m\351nte/;
                                }
                                # Las palabras terminadas en cin siempre llevan acento
                                elsif(!/[\341\351\355\363\372\374\342\352\356\364\373]/ && /cion$/)
                                {
                                        s/cion$/ci\363n/;
                                }
                                #Algunos monosilavos que S llevan acento
                                elsif(/^(va|ve|vi|da|di|fe|ha|he|no|ti|yo|ya|es)$/ )
                                {
                                       tr/aeio/\341\351\355\363/;
                                }
                                # Si no hay vocales la nica forma de leerlo es deletrearlo
                                elsif(! /[\341\351\355\363\372\374\342\352\356\364\373aeiouy?!\.,:;\-]/)
                                {
                                        if(!/[a-z]/ && (length($_) > 8))
                                        {
                                                $_ = "un monton de chirimbolitos"
                                        }
                                        elsif((length($_) > 20))
                                        {
                                                $_ = "un pal\341bro";
                                        }
                                        else
                                        {
                                                my $tmp = '';
                                                $tmp .= "$deletrear{$_} " foreach (split(//));
                                                $_ = $tmp;
                                        }
                                }
                        }
                }

                push(@salida, "$_$punto"); # Almecenamos y devolvemos el punto que quitamos
        }

        return join(' ', @salida);
}

# Transcribimos la frase a fonemas, para ello se la transcribe a fonemas
# realizando asimilaciones en la misma operacin, luego
# se la divide en palabras se crea el array fonetico, y
# se marcan las diferentes entonaciones de la frase.
# Por ultimo se pone todo junto y se lo convierte a sampa
sub transcribe_frase
{
        my($k, $l, @p);         # Variables auxiliares
        my $atona;              # Indicador de palabra atona
        my $aatona = 0;         # Indicador de palabra anterior tona
        my $num_silaba = 0;     # Nmero de la silaba actual
        my $cdp = -1;           # Comienzo de palabra
        my $pv  = -1;           # Primera vocal
        my $pva = -1;           # Primera vocal acentuada
        my $uv  = -1;           # ltima vocal
        my $uva = -1;           # ltima vocal acentuada
        my $usp = -1;           # ltimo signo de puntuacin
        my $pendiente;          # Pendiente de la entonacin

        local $_ = $_[0];
        local @fonemas = ();    # Cada uno de los fonemas de la frase
        local @entonacion = (); # Entonacin (pich) que corresponde a cada fonema

	# Eliminamos la posibilidad de muchas consonantes iguales seguidas y lo reducimos a un mximo de dos
        foreach $k ('b','c','d','f','g','h','j','k','l','m','n','p','q','r','s','t','v','w','x','y','z', '', "\361")
        {
                $l = "$k$k$k";
                while(s/$k$k$k/$k$k/go) { };
        }

        # Transcribe la frase a fonemas y realiza las asimilacines
        $_ = "# $_";
        s/([,:;\-])/$1\#/g;
        foreach $k (@txt2fonema)
        {
                s/$k->[0]/$k->[1]/g;
        }
        s/\#//g;
        s/^ //;

        # Aadimos una pausa inicial, pero no si el texto ya comienza en pausa (puntuacin)
        if(! /^ [:\-;\.!?,]/)
        {
                push(@fonemas, '#');
                push(@entonacion, "50\t0 120"); # Pausa inicial
                $usp = 0;
        }

        foreach (split /\s+/) # Dividimos en palabras
        {
                next if($_ eq '');

                if(/^[:\-;\.!?,]$/) # Es puntuacin?
                {
                        $l = $#entonacion;

			next if($fonemas[$l] eq '#');
			
                        $aatona = 0; # La puntuacin es en si misma una pausa y entonacin asi que no es atona

                        # Diferentes entonacines de la frase segn la puntuacin.
                        if(/\?/)
                        {
                                if($pva == -1)
                                {
                                        $entonacion[$pv] .= "\t30 110";
                                }
                                elsif($pv < $cdp)
                                {
                                        $entonacion[$pv] .= "\t80 150" if($pva < $cdp); # 90 170
                                }
                                $entonacion[$uv] .= "\t90 170"; # 90 180
                                $pendiente = 120;
                        }
                        elsif(/\!/)
                        {
                                $entonacion[$usp] .= "\t0 150";
                                $entonacion[$pva == -1 ? $pv : $pva] = "\t90 170" if($pv < $cdp);

                                $entonacion[$uva] = "\t30 180" if($uva >= $cdp);

                                $entonacion[$uv] .= "\t80 80" if($uv != $uva);
                                $entonacion[$l] .= "\t90 60" if($l != $uva);
                                $pendiente = 80;
                        }
                        elsif(/\./)
                        {
                                $entonacion[$uv] .= "\t80 80" if($uva != $uv); # "\t80 100";
                                $entonacion[$l] .= "\t80 100" if($l != $uva);
                                $pendiente = 100;
                        }
                        else
                        {
				if($l > 0)
				{
					if(/:/)
					{
        	                        	$entonacion[$uv] .= "\t30 110" if($pva == -1);
					}
					else
					{
        	                        	$entonacion[$l] .= "\t90 100";
        	                        }
                                }
                                $pendiente = 120;
                        }
                        push(@fonemas, '#'); # La coma es una pausa algo mas corta que las demas puntuaciones
                        push(@entonacion, (/,/ ? 150 : 250)."\t0 $pendiente");

                        $usp = $#entonacion;
                        $uv = $uva = $pv = $pva = -1;
                }
                else # O Es una palabra?
                {
                        $atona = defined($atonas{lc $_}) ? 1 : 0;

                        # Tras cada palabra tona aadimos un ligero cambio de entonacin
                        $entonacion[$#entonacion] .= "\t90 95" if($aatona && !$atona);

                        $aatona = $atona; # Guardamos el tipo de palabra de la palabra actual como anterior

                        s/([aeiou]:|[aeiou]1|.)/$1 /g; # Espaciamos los fonemas

                        @p = split /\s+/; # Dividimos la palabra en fonemas

                        # Aadimos los acentos a las palabras no tonas que no llevan tilde
                        # Dos casos, la palabras llanas terminadas en vocal, n o s,
                        # y las palabras graves terminadas en consonante que no sea n o s
                        if(!$atona && !/:/)
                        {
                                $l = $#p;
                                if($p[$l] =~ /[aeiousn1]$/)                                # Si termina en vocal n o s
                                {
                                        $k = $l - 1;
                                        $k-- while(($k >= 0) && ($p[$k] =~ /[aeiouWj]/));  # Buscamos primera consonante de la ltima silaba
                                        $k-- while(($k >= 0) && ($p[$k] !~ /[aeiou]/));    # Buscamos la ltima vocal de la slaba
                                        if(($k >= 0) && ($p[$k] =~ /[aeiou]/))
                                        {
                                                $p[$k] .= ':';                             # La acentuamos
                                                $l = 0;
                                        }
                                }
                                if($l > 1)
                                {
                                        if(($p[$l - 1] =~ /[aeiou]/) && ($p[$l] =~ /[aeiou]/) ||
                                           ($p[$l - 1] =~ /[aeioujW]/) && ($p[$l] !~ /[aeiou]/))
                                        {
                                                $p[$l - 1] .= ':';
                                        }
                                        elsif($l >= 2)
                                        {
                                                $p[$l - 2] .= ':' if(($p[$l - 2] =~ /[aeiou]/) &&
                                                  	            (($p[$l - 1] !~ /[aeiou]/) && ($p[$l] !~ /[aeiou]/) ||
                                                                     ($p[$l - 1] =~ /[iu]/) && ($p[$l] !~ /[aeiour]/)));
                                        }
                                }
                        }

                        $cdp = $#entonacion + 1; # Almacenamos el comienzo de la palabra
                        foreach (@p)
                        {
                                # Si es un fonema real
                                if(defined($duracion{$_}))
                                {
                                        push(@fonemas, $_);
                                        push(@entonacion, '');
                                        if(/^[aeiouWj]/)
                                        {
                                                # Si es el acento de la palabra corregimos la entonacin
                                                if(/:/)
                                                {
                                                        $uva = $#fonemas;
                                                        $pva = $uva if($pva == -1);

                                                        $entonacion[$cdp] .= "\t0 100";
                                                        $entonacion[$uva] .= "\t30 130";
                                                }

                                                $uv = $#fonemas;
                                                $pv = $uv if($pv == -1);
                                        }
                                }
                        }
                }
        }

        # Todas la tablas foneticas deben terminar en una pausa.
        if($fonemas[$#fonemas] ne '#')
        {
		$entonacion[$uv] .= "\t30 130" if($pva == -1); # Esto es para mejorar la entonacin en frases que solo contengan palabras tonas

                push(@fonemas, '#');
                push(@entonacion, "250\t0 120"); # Pausa final
        }

        # Cambiamos nuestra notacin fontica por la de Mbrola, aadimos las pausas
        # y la duracion de los distintos fonemas,
        # y lo aadimos a la phonetizacin que llevamos ya
        my @fonetizacion = ();
        for($l = 0; $l <= $#fonemas; $l++)
        {
                $k = $fonemas[$l];
                push(@fonetizacion, "$ttp2sampa{$k} $duracion{$k} $entonacion[$l]");
        }
        return @fonetizacion;
}

# Convierte los numero a su correcta forma en letras
sub numero2letras
{
        my @salida = ();
        my @n = split(/([\.,\-\252\272])/, $_[0]);
        my $i;
        for($i = 0; $i <= $#n; $i++)
        {
                push(@salida, $n[$i] eq ''   ? '' :
                              $n[$i] eq '.'  ? ' punto ' :
                              $n[$i] eq ','  ? ' coma ' :
                              $n[$i] eq '-'  ? ' menos ' :
                              $n[$i] =~ /[\252\272]/ ? ' ' :
                              $n[$i + 1] =~ /[\252\272]/ ? ordinal_letra($n[$i], $n[$i + 1]) :
                                                        numero_letra($n[$i]));

        }
        return join(' ', @salida);
}

sub numero_letra
{
        my $numero = $_[0];

        while($numero =~ s/^0//) {};

        return $unidades[$numero] if ($numero < 10);

        if ($numero < 100)
        {
                @_ = split//,$numero;
                return do
                        {
                                $_[1] == 0      ? $decenas1[$_[0]]:
                                $numero < 20    ? $excepciones[$_[1]]:
                                                  "$decenas2[$_[0]]$unidades[$_[1]]";
                        }
        }
        elsif ($numero < 1000)
        {
                @_ = split//,$numero;
                return $centenas[0] if($numero == 100);
                return $centenas[$_[0]]. do
                        {
                                ($_[1] + $_[2]) == 0    ? '':
                                $_[1] == 0              ? " $unidades[$_[2]]":
                                $_[2] == 0              ? " $decenas1[$_[1]]":
                                $_[1] == 1              ? " $excepciones[$_[2]]":
                                                          " $decenas2[$_[1]]$unidades[$_[2]]";
                        }
        }
        elsif($numero < 1000000)
        {
                my $miles = int($numero / 1000);
                my $cientos = $numero % 1000;

                return ($miles == 1 ? '' : &numero_letra($miles).' ').'mil'.($cientos == 0 ? '' : ' '.&numero_letra($cientos));
        }
        else
        {
                my $i = 0;
                my $letras = '';
                while ($numero > 0)
                {
                        if($numero < 1000000)
                        {
                                $_ = $numero;
                                $numero = 0;
                        }
                        else
                        {
                                $_ = substr($numero, length($numero) - 6);
                                $numero = substr($numero, 0, length($numero) - 6);
                        }
                        if($_ != 0)
                        {
                                $_ = &numero_letra($_).' '.$prefijos[$i].(!$i ? '' : $_ > 1 ?  'llones' : 'lln');
                                s/uno/un/ if($i != 0);
                                $letras = $_." $letras";
                        }
                        $i++;
                }
                $letras =~ s/cero//g;
                $letras =~ tr/ //s;
                return $letras;
        }
}

sub ordinal_letra
{
        my $numero = $_[0];
        my $genero = $_[1] eq "\252" ? 'a' : 'o';

        return "$uni_ord[$numero]$genero" if ($numero < 10);

        if ($numero < 100)
        {
                @_ = split//,$numero;
                return do
                        {
                                $_[1] == 0      ? $dec_ord[$_[0]]:
                                $numero < 13    ? $excep_ord[$_[1]]:
                                                  "$dec_ord[$_[0]]$genero $uni_ord[$_[1]]";
                        }.$genero;
        }
        elsif ($numero < 1000)
        {
                @_ = split//,$numero;
                return "$pref_ord[$_[0]]centsim$genero". do
                        {
                                ($_[1] + $_[2]) == 0    ? '':
                                $_[1] == 0              ? " $uni_ord[$_[2]]$genero":
                                $_[2] == 0              ? " $dec_ord[$_[1]]$genero":
                                ($_[1] == 1) && ($_[2] =~ /[012]/) ? " $excep_ord[$_[2]]$genero":
                                                          " $dec_ord[$_[1]]$genero $uni_ord[$_[2]]$genero";
                        }
        }
        elsif($numero < 10000)
        {
                return "milsim$genero" if($numero == 1000);
                return $pref_ord[substr($numero, 0, 1)]."milsim$genero ".ordinal_letra($numero % 1000, $_[1])
        }
        else
        {
                return 'el ordinal de '.numero_letra($numero);
        }
}

1;
